"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;
exports.Code = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _prismAsyncLight = _interopRequireDefault(require("react-syntax-highlighter/prism-async-light"));

var _styledComponents = require("styled-components");

var _supportedLanguages = require("./supportedLanguages");

var _themeBuilder = require("./themes/themeBuilder");

var Code =
/*#__PURE__*/
function (_PureComponent) {
  (0, _inherits2.default)(Code, _PureComponent);

  function Code() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, Code);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(Code)).call.apply(_getPrototypeOf2, [this].concat(args)));
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "state", {
      language: (0, _supportedLanguages.normalizeLanguage)('')
    });
    return _this;
  }

  (0, _createClass2.default)(Code, [{
    key: "registerLanguage",
    value: function () {
      var _registerLanguage = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(language) {
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (_prismAsyncLight.default.astGenerator) {
                  _context.next = 3;
                  break;
                }

                _context.next = 3;
                return _prismAsyncLight.default.astGeneratorPromise;

              case 3:
                if (!_prismAsyncLight.default.astGenerator.registered(language)) {
                  _context.next = 5;
                  break;
                }

                return _context.abrupt("return", this.setState({
                  language: language
                }));

              case 5:
                if (_supportedLanguages.languageLoaders[language]) {
                  _context.next = 7;
                  break;
                }

                return _context.abrupt("return", undefined);

              case 7:
                _context.next = 9;
                return _supportedLanguages.languageLoaders[language]();

              case 9:
                return _context.abrupt("return", this.setState({
                  language: language
                }));

              case 10:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function registerLanguage(_x) {
        return _registerLanguage.apply(this, arguments);
      };
    }()
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var language = (0, _supportedLanguages.normalizeLanguage)(this.props.language);
      this.registerLanguage(language);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(_ref) {
      var prevLanguage = _ref.language;
      var language = (0, _supportedLanguages.normalizeLanguage)(this.props.language);

      if (prevLanguage !== language) {
        this.registerLanguage(language);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _applyTheme = (0, _themeBuilder.applyTheme)(this.props.theme),
          inlineCodeStyle = _applyTheme.inlineCodeStyle;

      var props = {
        language: this.state.language,
        PreTag: 'span',
        style: this.props.codeStyle || inlineCodeStyle,
        showLineNumbers: this.props.showLineNumbers,
        lineNumberContainerStyle: this.props.lineNumberContainerStyle,
        codeTagProps: this.props.codeTagProps
      };
      return _react.default.createElement(_prismAsyncLight.default, props, this.props.text);
    }
  }]);
  return Code;
}(_react.PureComponent);

exports.Code = Code;
(0, _defineProperty2.default)(Code, "defaultProps", {
  language: '',
  theme: {},
  showLineNumbers: false,
  lineNumberContainerStyle: null,
  codeTagProps: {}
});
var CodeWithTheme = (0, _styledComponents.withTheme)(Code);
var emptyTheme = {};

function _default(props) {
  return _react.default.createElement(_styledComponents.ThemeProvider, {
    theme: emptyTheme
  }, _react.default.createElement(CodeWithTheme, props));
}