import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React, { PureComponent } from 'react';
import SyntaxHighlighter from 'react-syntax-highlighter/prism-async-light';
import { withTheme, ThemeProvider } from 'styled-components';
import { normalizeLanguage, languageLoaders } from './supportedLanguages';
import { applyTheme } from './themes/themeBuilder';
export var Code =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(Code, _PureComponent);

  function Code() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Code);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Code)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      language: normalizeLanguage('')
    });

    return _this;
  }

  _createClass(Code, [{
    key: "registerLanguage",
    value: function () {
      var _registerLanguage = _asyncToGenerator(
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee(language) {
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (SyntaxHighlighter.astGenerator) {
                  _context.next = 3;
                  break;
                }

                _context.next = 3;
                return SyntaxHighlighter.astGeneratorPromise;

              case 3:
                if (!SyntaxHighlighter.astGenerator.registered(language)) {
                  _context.next = 5;
                  break;
                }

                return _context.abrupt("return", this.setState({
                  language: language
                }));

              case 5:
                if (languageLoaders[language]) {
                  _context.next = 7;
                  break;
                }

                return _context.abrupt("return", undefined);

              case 7:
                _context.next = 9;
                return languageLoaders[language]();

              case 9:
                return _context.abrupt("return", this.setState({
                  language: language
                }));

              case 10:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function registerLanguage(_x) {
        return _registerLanguage.apply(this, arguments);
      };
    }()
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var language = normalizeLanguage(this.props.language);
      this.registerLanguage(language);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(_ref) {
      var prevLanguage = _ref.language;
      var language = normalizeLanguage(this.props.language);

      if (prevLanguage !== language) {
        this.registerLanguage(language);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _applyTheme = applyTheme(this.props.theme),
          inlineCodeStyle = _applyTheme.inlineCodeStyle;

      var props = {
        language: this.state.language,
        PreTag: 'span',
        style: this.props.codeStyle || inlineCodeStyle,
        showLineNumbers: this.props.showLineNumbers,
        lineNumberContainerStyle: this.props.lineNumberContainerStyle,
        codeTagProps: this.props.codeTagProps
      };
      return React.createElement(SyntaxHighlighter, props, this.props.text);
    }
  }]);

  return Code;
}(PureComponent);

_defineProperty(Code, "defaultProps", {
  language: '',
  theme: {},
  showLineNumbers: false,
  lineNumberContainerStyle: null,
  codeTagProps: {}
});

var CodeWithTheme = withTheme(Code);
var emptyTheme = {};
export default function (props) {
  return React.createElement(ThemeProvider, {
    theme: emptyTheme
  }, React.createElement(CodeWithTheme, props));
}